//Exif.h

#ifndef _EXIF_H_
#define _EXIF_H_

#include <stdio.h>

#ifndef _cplusplus
 #define bool int
 #define true  1
 #define false 0
#endif

static bool  type;  //li[`
static short size;  //APP1 TCY
static int   offset;//1Ԗڂ̃fBNgւ̃ItZbg

//fBNg\
typedef struct EXIF_DIRECTORYtag{
	unsigned short TAG ;
	unsigned short Type;
	unsigned short DataNum;
	unsigned int   Data;
}EXIF_DIRECTORY;

int LoadHead(FILE *File){
	unsigned char Head    [0x10]={0};//wb_
	unsigned char Directry[0x08]={0};//fBNg
	int  i;
	//wb_擾
	for(i=0;i<0x10;i++){
		//ǂݍ
		Head[i]=fgetc(File);
	}
	//ExifmF
	if(Head[0x00]!=0xFF || Head[0x01]!=0xD8)return -1;//SOI}[J[̊mF
	if(Head[0x02]!=0xFF || Head[0x03]!=0xE1)return -2;//APP1}[J[̊mF
	if(Head[0x06]!=0x45 || Head[0x07]!=0x78 || Head[0x08]!=0x69 || Head[0x09]!=0x66 || Head[0x0A]!=0x00 || Head[0x0B]!=0x00)return -3;//EXIF}[J[̊mF
	//wb_TCY擾
	size=(Head[0x04]<<8|Head[0x05])-6;
	//i[`擾
	type=(Head[0x0C]==0x4D)?true:false;//trueȂ烂g[
	
	//fBNg擾
	for(i=0;i<0x08;i++){
		//ǂݍ
		Directry[i]=fgetc(File);
	}
	return (type)?Directry[4]<<8|Directry[5]:Directry[4]|Directry[5]<<8;
}

bool LoadDirectry(int offset,EXIF_DIRECTORY *pED,FILE *File){
	unsigned char Buf[12];//擾f[^̈ꎞi[ꏊ(ō4oCg)
	int  i=0;
	
	if(fseek(File,offset*12+0x16,SEEK_SET))return false;
	
	for(i=0;i<12;i++){
		Buf[i]=fgetc(File);
		printf("%02d:0x%02X\n",i,Buf[i]);
	}
	pED->TAG    =(type)?Buf[0]<<8 |Buf[1]:Buf[0]|Buf[1]<<8;
	pED->Type   =(type)?Buf[2]<<8 |Buf[3]:Buf[2]|Buf[3]<<8;
	pED->DataNum=(type)?Buf[4]<<32|Buf[5]<<16|Buf[6]<<8 |Buf[7] :Buf[7]<<32 |Buf[6]<<16 |Buf[5]<<8|Buf[4];
	pED->Data   =(type)?Buf[8]<<32|Buf[9]<<16|Buf[10]<<8|Buf[11]:Buf[11]<<32|Buf[10]<<16|Buf[9]<<8|Buf[8];
	return true;
}

#endif